<template>
    <div v-loading="loading" class="render-all-games flex flex-col gap-4">
      <template v-for="groupKey in keyToMap" :key="groupKey">
        <div class="relative" :class="isMobile && 'group-row-mobile'" v-if="gameForDisplay[groupKey] && gameForDisplay[groupKey].length">
          <div class="flex items-center justify-between relative pb-2" :class="isMobile && '!pb-2 px-2'">
              <div class="flex gap-1 items-center">
                  <!-- <svg-icon v-if="['Special_Selection', 'Hot_Games', 'New_Games'].includes(groupKey)"
                      :svgName="`icon-${groupKey.toLowerCase().replace(
                      '_',
                      '-'
                      )}`"
                      class="w-6 h-6"
                  /> -->
                   <img
                      v-if="['Special_Selection', 'Hot_Games', 'New_Games'].includes(groupKey)"
                      class="w-6 h-6"
                      v-lazy="getAssetImage(`assets/theme/playful/images/game-filter/${groupKey.toLowerCase().replace(
                        '_',
                        '-'
                      )}.svg`)" alt=""
                      />
                  <img v-else
                    class="w-6 h-6"
                    v-lazy="getAssetImage(`assets/theme/playful/images/game-type/${groupKey.toLowerCase().replace(
                      '_',
                      '-'
                      ).split(' ')[0]}.svg`)" alt=""
                    />
                  <span class="font-bold text-sm capitalize --text2">{{ $t(groupKey.toLocaleLowerCase()) }}</span>
              </div>
              <div class="flex gap-1 items-center">
                  <div v-if="!isMobile" class="btn-prev-carousel cus-swiper-button-prev cursor-pointer" :class="`button-prev-${groupKey.replace('568', '').split(' ')[0]}`"
                    @click="() => handleClick1(groupKey)">
                      <svg-icon
                          svgName="left-arrow-fill"
                          class="w-6 h-6"
                      />
                  </div>
                  <div v-if="!isMobile" class="btn-next-carousel cus-swiper-button-next cursor-pointer" :class="`button-next-${groupKey.replace('568', '').split(' ')[0]}`"
                    @click="() => handleClick(groupKey)">
                      <svg-icon
                          svgName="left-arrow-fill"
                          class="w-6 h-6"
                      />
                  </div>
                  <div class="view-all-button cursor-pointer" @click="() => onClickViewAll(groupKey)" :id="ID.VIEW_ALL_GAME">
                      <span class="text-xs text-[var(--text4\_w)] pointer-events-none">{{ $t('View All') }}</span>
                  </div>
              </div>
          </div>
          <template v-if="gameForDisplay[groupKey]">
            <div class="flex overflow-y-hidden row-container" :class="[groupKey.replace('568', ''), isMobile ? 'overflow-x-scroll mx-2' : 'overflow-x-hidden']">
                  <div v-for="(game, index) in gameForDisplay[groupKey]" :key="index" class="flex justify-center" v-intersection-observer="gameForDisplay[groupKey].length - 1 === index ? onReach : undefined">
                      <div
                        v-if="!game.IsMaintain"
                        class="cursor-pointer flex flex-col justify-center items-center game-card"
                        :id="groupKey"
                        @click="authenticated ? handlePlayGame(game, 850, 850, 'GameLobby') : (isMobile ? toggleLoginRegisterDialog() : redirectToLogin())"
                      >
                        <div class="h-[180px] relative aspect-[1/1] overflow-hidden top-part" :class="{'group' : !isMobile}">
                          <IconFavorite
                            :ForMobile="isMobile"
                            :toggle-dialog="isMobile"
                            :gameData="game"
                            :checkIsFavourite="checkIsFavourite"
                            :redirectToLogin="redirectToLogin"
                            :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"/>
                          <span class="icon-status" :class="checkStatus(game)"></span>
                          <img
                            v-lazy="isImageVersionExist(game.GameIconUrl)"
                            :alt="game.GameName"
                            class="object-cover object-top w-full h-full rounded-2xl"
                          />
                          <div class="play__now__overlay group-hover:opacity-100 pb-4 items-end">
                            <span class="play__now__content_for_animate bg-primary">{{ $t("play_now") }}</span>
                          </div>
                        </div>
                      <div class="leading-[35px] text-[var(--text2)] text-center truncate w-[180px] bottom-part text-xs">{{ game.GameName }}</div>
                      </div>
                      <div v-else>
                        <div class="h-[180px] relative aspect-[1/1] overflow-hidden" :class="{'group' : !isMobile}">
                          <IconFavorite
                            :ForMobile="isMobile"
                            :toggle-dialog="isMobile"
                            :gameData="game"
                            :checkIsFavourite="checkIsFavourite"
                            :redirectToLogin="redirectToLogin"
                            :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"/>
                          <span class="icon-status" :class="checkStatus(game)"></span>
                          <img
                            v-lazy="isImageVersionExist(game.GameIconUrl)"
                            :alt="game.GameName"
                            class="object-cover object-top w-full h-full rounded-2xl"
                          />
                          <div class="play__now__overlay group-hover:opacity-100 pb-4 items-end">
                            <span class="play__now__content_for_animate bg-primary">{{ $t("play_now") }}</span>
                          </div>
                        </div>
                      <div class="leading-[35px] text-[var(--text2)] text-center truncate w-[180px] text-xs">{{ game.GameName }}</div>
                      </div>
                  </div>
                </div>
          </template>
          <ElBacktop class="arrowTop" :right="30" :bottom="30">
            <div class="w-[35px] h-[35px] flex items-center justify-center">
              <font-awesome-icon icon="arrow-up" class="text-black" />
            </div>
          </ElBacktop>
        </div>
      </template>
      <div
        v-show="games.length === 0 && !loading"
        class="col-span-3 my-[60px] p-2 overflow-hidden text-4xl text-center truncate no-data text-ellipsis"
      >
      <span v-if="activeTab !== 'favorite'">{{ $t("no_games_please_come_back_later") }}</span>
      <span v-else>{{ $t('No game has been added to favorite.') }}</span>
      </div>
    </div>
  </template>

  <script lang="ts">
  import _ from 'lodash';
  import { computed, defineComponent, PropType, ref, watch } from "vue";
  import { ElBacktop } from "element-plus";
  import { GameBsi, IGameBsi } from "@/models/bsiGameList";
  import { handleGameEntryOpenWindow } from "@/composables/useTheme";
  import { store } from "@/store";
  import { Navigation, Pagination } from "swiper";
  import { useGameEntryComponent } from "@/composables/useTheme";
  import { useIntersectionObserver } from '@vueuse/core'


  const endOfList = ref(null);

  export default defineComponent({
    name: "GameEntry",
    components: {
      ElBacktop,
    },
    props: {
      loading: {
        type: Boolean,
        default: false,
      },
      games: {
        type: Array as PropType<IGameBsi[]>,
        default: () => [],
      },
      isHasGroupTitle: {
        type: Boolean,
        default: false,
      },
      groupTitle: {
        type: String,
        default: "",
      },
      classGameName: {
        type: String,
        default: "",
      },
      handlePlayGame: {
        type: Function,
        required: true,
        default: handleGameEntryOpenWindow,
      },
      grid: {
        type: Number,
        default: 6,
      },
      gap: {
        type: Number,
        default: 2,
      },
      showStaus: {
        type: Boolean,
        default: false,
      },
    },
    setup(props) {
      const {
        activeTab,
      } = useGameEntryComponent();
      const {
        setAndUnsetGameToFavourite,
        checkIsFavourite,
        redirectToLogin,
      } = useAddToFavorite();
      const authenticated = computed(() => store.state.auth);
      const checkStatus = (game: IGameBsi): string => {
        let status = "disabled";
        if (props.showStaus) {
          if (game.IsNewGame && !game.IsHotGame) status = "new";
          if (game.IsHotGame) status = "hot";
        }
        return status;
      };
      const keyToMap = [
        '568Win Games',
        'Special_Selection',
        'Hot_Games',
        'New_Games',
        'Slots',
        'ArcadeGames',
        'TableGames',
        'FishingGames',
        'LotteryGames',
      ];
      const gameTypes = computed(() => store.state.gameTabProviderList.SeamlessGameGameTypeList)
      const groupedGame = computed(() => {
        // @ts-ignore
        const isSpecialSeelectionGroup = props.games.filter((game) => game.IsSpecialSelection);
        const is568WinGroup = props.games.filter((game) => game.GameProviderName.toLowerCase().includes('568win'));
        const isHotGroup = props.games.filter((game) => game.IsHotGame);
        const isNewGroup = props.games.filter((game) => game.IsNewGame);

        const groupByGameType = _.pickBy(_.groupBy(props.games, 'GameType'), (value, key) =>
          keyToMap.slice(4).includes(key)
        );

        const obj: Record<string, IGameBsi[]>  = {
          '568Win Games': is568WinGroup,
          Special_Selection: isSpecialSeelectionGroup,
          Hot_Games: isHotGroup,
          New_Games: isNewGroup,
          ...groupByGameType
        };
        return obj;
      });


      const chunkArray = (array: GameBsi[], size: number) => {
          const chunks = [];
          for (let i = 0; i < array.length; i += size) {
              chunks.push(array.slice(i, i + size));
          }
          return chunks;
      }

      const splitGameIntoChunk  = computed(() => {
        const chunkSize = 7;

        const result = {};
        for (const key in groupedGame.value) {
        if (groupedGame.value.hasOwnProperty(key)) {
            // @ts-ignore
            result[key] = chunkArray(groupedGame.value[key], chunkSize);
          }
        }
        return result;
      });
      const gameForDisplay = ref<Record<string, GameBsi[]>>({});

      watch(() => splitGameIntoChunk.value, () => {
          Object.entries(splitGameIntoChunk.value).forEach((item) => {
              // @ts-ignore
              if (!gameForDisplay.value[item[0]]) gameForDisplay.value[item[0]] = item[1][0];
          })
      });

      const handleDisableButton = (groupKey: string, container: HTMLElement) => {
        const formatKey = groupKey.replace('568', '').split(' ')[0];
        const leftMax = container.scrollWidth - container.clientWidth;
        const prevButton = document.querySelector(`.render-all-games .button-prev-${formatKey}`);
        const nextButton = document.querySelector(`.render-all-games .button-next-${formatKey}`);
        const isFirstItemInView = Number(container.scrollLeft) === 0;
        // @ts-ignore
        const isLastItemInView = Number(container.scrollLeft) === Number(leftMax);
        if (nextButton) {
          if (isLastItemInView) nextButton.classList.add('pointer-events-none', 'opacity-50');
          else nextButton.classList.remove('pointer-events-none', 'opacity-50');
        }
        if (prevButton) {
          if (isFirstItemInView) prevButton.classList.add('pointer-events-none', 'opacity-50');
          else prevButton.classList.remove('pointer-events-none', 'opacity-50');
        }
      };

      function checkScreenSize() {
          var screenWidth = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
          if (screenWidth > 584) {
            Object.keys(gameForDisplay.value).forEach((item) => {
              if (gameForDisplay.value[item]) {
                const container = document.querySelector(`.row-container.${item}`) as HTMLElement;
                if (container) handleDisableButton(item, container);
              }
            });
          }
      }

      onMounted(() => {
        if (Object.entries(splitGameIntoChunk.value).length) {
          Object.entries(splitGameIntoChunk.value).forEach((item) => {
            // @ts-ignore
            if (!gameForDisplay.value[item[0]]) gameForDisplay.value[item[0]] = item[1][0];
          })
        }
        window.addEventListener('resize', checkScreenSize);
      });
      const isImageVersionExist = (imageURL: string): string => {
        if (_.includes(imageURL, '?v=')) {
          return imageURL;
        }
        return `${imageURL}?v=${store.state.imageVersion}`;
      };

      const indexObject: Record<string, number> = {};

      const checkReachEnd = (groupKey: string) => {
        // @ts-ignore
        if (!indexObject[groupKey] || splitGameIntoChunk.value[groupKey].length > indexObject[groupKey]) indexObject[groupKey] = Object.keys(indexObject).includes(groupKey)
          ? indexObject[groupKey] + 1
          : 1;
          // @ts-ignore
          if (splitGameIntoChunk.value[groupKey].length > indexObject[groupKey]) splitGameIntoChunk.value[groupKey][indexObject[groupKey]].forEach((item) => {
            gameForDisplay.value[groupKey].push(item);
          });
      };

      const modules = [Navigation, Pagination];

      const handleClick = (groupKey: string) => {
        const container = document.querySelector(`.row-container.${groupKey.replace('568', '').split(' ')[0]}`) as HTMLElement;
        const containerStyle = getComputedStyle(container);
        // @ts-ignore
        if (container && container.children[0].offsetWidth) container.scrollBy({ left: container.children[0].offsetWidth + parseFloat(containerStyle.columnGap), behavior: 'smooth' });
        setTimeout(() => {
          if (container) {
            handleDisableButton(groupKey, container);
          }
        }, 600);
      };
      const handleClick1 = (groupKey: string) => {
        const container = document.querySelector(`.row-container.${groupKey.replace('568', '').split(' ')[0]}`) as HTMLElement;
        const containerStyle = getComputedStyle(container);
        // @ts-ignore
        if (container && container.children[0].offsetWidth) container.scrollBy({ left: -container.children[0].offsetWidth - parseFloat(containerStyle.columnGap), behavior: 'smooth' });
        setTimeout(() => {
          if (container) {
            handleDisableButton(groupKey, container);
          }
        }, 600);
      };
      const router = useRouter();
      const onClickViewAll = (filterParam: string) => {
        if (['New_Games', 'Hot_Games', 'Special_Selection'].includes(filterParam)) router.push(`/games?f=${filterParam.replaceAll('_', ' ')}`);
        else router.push(`/games/${filterParam}`)
      };

      const { getAssetImage, toggleLoginRegisterDialog } = commonHelper;
      const isMobile = !useIsDesktop()

      const onReach = (event: any) => {
        const id = event[0].target.firstChild.attributes.id.value;
        const parentEl = event[0].target.parentElement;
        const prevButton = document.querySelector(`.render-all-games .button-prev-${id.replace('568', '').split(' ')[0]}`);
        const nextButton = document.querySelector(`.render-all-games .button-next-${id.replace('568', '').split(' ')[0]}`);
        const leftMax = parentEl.scrollWidth - parentEl.clientWidth;
        const isFirstItemInView = Number(parentEl.scrollLeft) === 0;
        const isLastItemInView = Number(leftMax) === Number(parentEl.scrollLeft);
        if (event[0].isIntersecting) {
          checkReachEnd(id)
        }
        if (prevButton) {
          if (isFirstItemInView) prevButton.classList.add('pointer-events-none', 'opacity-50');
        }
        if (nextButton) {
          if (isLastItemInView) nextButton.classList.add('pointer-events-none', 'opacity-50');
        }
      };
      return {
        authenticated,
        checkStatus,
        isImageVersionExist,
        setAndUnsetGameToFavourite,
        checkIsFavourite,
        redirectToLogin,
        activeTab,
        groupedGame,
        modules,
        handleClick,
        handleClick1,
        endOfList,
        gameForDisplay,
        onClickViewAll,
        checkReachEnd,
        getAssetImage,
        isMobile,
        toggleLoginRegisterDialog,
        onReach,
        keyToMap,
      };
    },
  });
  </script>
  <style scoped lang="scss">
  [layout="playful"][data-device="mobile"] {
  .arrowTop {
    display: none;
  }
}
  .render-all-games {
    width: 100%;
      @media screen and (max-width: 360px) {
        .row-container {
          gap: 8px;
        }
        .top-part {
          height: 104px;
          width: 104px;
        }
        .bottom-part {
          width: 104px;
        }
      }
      @media screen and (min-width: 361px) {
        .row-container {
          gap: 8px;
        }
        .top-part {
          height: 104px;
          width: 104px;
        }
        .bottom-part {
          width: 104px;
        }
      }
      @media screen and (min-width: 584px) {
        .row-container {
          gap: 8px;
        }
        .top-part {
          height: 156px;
          width: 156px;
        }
        .bottom-part {
          width: 156px;
        }
      }
      @media screen and (min-width: 960px) {
        .row-container {
          gap: 24px;
        }
        .top-part {
          height: 180px;
          width: 180px;
        }
        .bottom-part {
          width: 180px;
        }
      }
  .swiper {
    overflow: hidden;
    margin-left: 0;
    margin-right: 0;
    width: 100%;

    :deep(.swiper-button-prev), :deep(.swiper-button-next) {
      display: none;
    }
    :deep(.swiper-slide) {
      max-width: 200px;
    }
  }
  .group-row-mobile {
    &:after,
    &:before {
      content: '';
      position: absolute;
      height: calc(100% - 32px - 35px);
      width: 24px;
      filter: progid:DXImageTransform.Microsoft.gradient(startColorstr="#020024",endColorstr="#000000",GradientType=1);
      z-index: 9;
      top: 32px;
    }

    &:before {
      left: 0;
      background: rgb(var(--background2_nonrgb));
      background: -moz-linear-gradient(90deg, rgba(var(--background2_nonrgb),1) 0%, rgba(0,0,0,0) 100%);
      background: -webkit-linear-gradient(90deg, rgba(var(--background2_nonrgb),1) 0%, rgba(0,0,0,0) 100%);
      background: linear-gradient(90deg, rgba(var(--background2_nonrgb),1) 0%, rgba(0,0,0,0) 100%);
    }

    &:after {
      right: 0;
      background: rgb(var(--background2_nonrgb));
      background: -moz-linear-gradient(90deg, rgba(var(--background2_nonrgb),0) 0%, rgba(0,0,0,1) 100%);
      background: -webkit-linear-gradient(90deg, rgba(var(--background2_nonrgb),0) 0%, rgba(0,0,0,1) 100%);
      background: linear-gradient(90deg, rgba(var(--background2_nonrgb),0) 0%, rgba(var(--background2_nonrgb)) 100%);
    }
  }
  .play {
    border-color: transparent transparent transparent var(--primary);
    border-width: 6px 0 6px 12px;
    margin-left: 3px;
  }
  .cus-swiper-button-next {
    rotate: 180deg;
  }

  .cus-swiper-button-next, .cus-swiper-button-prev {
    height: 28px;
    width: 32px;
    border-radius: 4px;
    background: linear-gradient(0deg, rgba(255, 255, 255, 0.05) 0%, rgba(255, 255, 255, 0.05) 100%), var(--background5);
    display: flex;
    justify-content: center;
    align-content: center;
    align-items: center;
  }
  .view-all-button {
    height: 28px;
    padding-left: 8px;
    padding-right: 8px;
    color: var(--text2);
    border-radius: 4px;
    background: linear-gradient(0deg, rgba(255, 255, 255, 0.05) 0%, rgba(255, 255, 255, 0.05) 100%), var(--background5);
    display: flex;
    justify-content: center;
    align-content: center;
    align-items: center;
  }
}
  .blog-game {
    .icon-status:not(.disabled) {
      position: absolute;
      width: 60px;
      height: 28px;
      border-top-left-radius: 16px;
      border-bottom-right-radius: 16px;
      top: 0px;
      left: 0px;
      color: var(--text5);
      text-align: center;
      font-family: "Roboto";
      font-style: normal;
      font-weight: 700;
      font-size: 16px;
      letter-spacing: 0.02em;
      z-index: 20;
      &.new {
        background-color: #2A71DC;
        &::after {
          content: "New";
          position: absolute;
          top: 6px;
          left: 15px;
        }
      }
      &.hot {
        background-color: #FF264D;
        &::after {
          content: "Hot";
          position: absolute;
          top: 6px;
          left: 15px;
        }
      }
    }
  }
  .play__now__overlay {
    @apply opacity-0 group-hover:opacity-100 transition-opacity duration-[250ms] absolute top-0 z-10 w-full h-full grid rounded-lg justify-center bg-[#05071ecc];
  }
  .play__now__content_for_animate {
    @apply flex justify-center items-center text-sm font-bold text-white rounded-md h-8 w-fit px-[5px] min-w-[120px];
  }
  .favourite-no-animation {
    @apply absolute top-[5px] right-[5px] h-[32px] w-[32px] z-20 rounded-md bg-[rgba(242,116,139,0.2)] items-center justify-center flex;
  }
  .favourite-animation {
    @apply absolute top-[5px] right-[5px] h-[32px] w-[32px] z-20 rounded-md;
  }
  @keyframes fadeInFromBottom {
    0% {
      opacity: 0;
      transform: translateY(100%);
    }
    100% {
      opacity: 1;
      transform: translateY(0);
    }
  }
  @keyframes fadeInFromTop {
    0% {
      opacity: 0;
      transform: translateY(-100%);
    }
    100% {
      opacity: 1;
      transform: translateY(0);
    }
  }
  @keyframes fadeOutToTop {
    0% {
      opacity: 0;
      transform: translateY(-100%);
    }
    100% {
      opacity: 1;
      transform: translateY(0);
    }
  }
  @keyframes scaleAnimation {
    0% {
      transform: scale(1);
    }
    50% {
      transform: scale(1.5);
    }
    100% {
      transform: scale(1);
    }
  }
  @keyframes fadeColor {
    0% {
      background: rgba(242, 116, 139, 1);
    }
    50% {
      background: rgba(242, 116, 139, 1);
    }
    100% {
      background: rgba(242, 116, 139, 0.2);
    }
  }
  .group:hover .play__now__content_for_animate {
    animation: fadeInFromBottom .5s ease-in-out;
  }
  .group:hover .favourite-animation {
    @apply opacity-100;
    animation: fadeInFromTop .5s ease-in-out forwards;
  }
  .colorFade {
    animation: fadeColor 2s ease-in-out forwards;
  }
  .scale-animation {
    animation-iteration-count: 1;
    animation: scaleAnimation 1s normal forwards ease-in-out;
  }
  </style>
  <style>
  .el-popper.is-light.game-name span {
    color: #5f5f5f;
  }
  .el-popper.is-light.game-name .el-popper__arrow::before {
    background: #fff;
  }
  </style>
